@import 'custom-variables';
@import 'mixins/mixins';

///////////////////////////////////////
// * 1. Text
// * 2. hoverable
// * 3. animations
///////////////////////////////////////


// ----------------
// * 1. Text
// ----------------
.t-h300 {
  @include h300;
}

.t-h500 {
  @include h500;
}

.t-h700 {
  @include h700;
}

.t-h800 {
  @include h800;
}

.t-h1000 {
  @include h1000;
}

.ellipsis {
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}

.t-uppercase {
  text-transform: uppercase;
}
.t-weight-500 {
  font-weight: 500;
}
.t-weight-700 {
  font-weight: 700;
}
.t-size-13 {
  font-size: 13px;
}

// ----------------
// * 2. Hoverable
// ----------------
.hoverable {
  -webkit-transition: -webkit-box-shadow .25s;
  transition: -webkit-box-shadow .25s;
  transition: box-shadow .25s;
  transition: box-shadow .25s, -webkit-box-shadow .25s;
}

.hoverable:hover {
  -webkit-box-shadow: 0 8px 17px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19) !important;
  box-shadow: 0 8px 17px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19) !important;
}

.hoverable-light {
  -webkit-transition: -webkit-box-shadow .25s;
  transition: -webkit-box-shadow .25s;
  transition: box-shadow .25s;
  transition: box-shadow .25s, -webkit-box-shadow .25s;
}

.hoverable-light:hover {
  -webkit-box-shadow: 0 8px 17px 0 rgba(255, 255, 255, 0.2), 0 6px 20px 0 rgba(255, 255, 255, 0.19);
  box-shadow: 0 8px 17px 0 rgba(255, 255, 255, 0.2), 0 6px 20px 0 rgba(255, 255, 255, 0.19);
}


.hideable {
  .hover-visible {
    display: none;
  }

}

.hideable:hover {
  .hover-visible {
    display: block;
  }
}


// ----------------
// * 3. Animations
// ----------------
.pulse {
  overflow: visible;
  position: relative;
}

.pulse::before {
  content: '';
  display: block;
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  background-color: inherit;
  border-radius: inherit;
  -webkit-transition: opacity .3s, -webkit-transform .3s;
  transition: opacity .3s, -webkit-transform .3s;
  transition: opacity .3s, transform .3s;
  transition: opacity .3s, transform .3s, -webkit-transform .3s;
  -webkit-animation: pulse-animation 1s cubic-bezier(0.24, 0, 0.38, 1) infinite;
  animation: pulse-animation 1s cubic-bezier(0.24, 0, 0.38, 1) infinite;
  z-index: -1;
}

@-webkit-keyframes pulse-animation {
  0% {
    opacity: 1;
    -webkit-transform: scale(1);
            transform: scale(1);
  }
  50% {
    opacity: 0;
    -webkit-transform: scale(1.5);
            transform: scale(1.5);
  }
  100% {
    opacity: 0;
    -webkit-transform: scale(1.5);
            transform: scale(1.5);
  }
}

@keyframes pulse-animation {
  0% {
    opacity: 1;
    -webkit-transform: scale(1);
            transform: scale(1);
  }
  50% {
    opacity: 0;
    -webkit-transform: scale(1.5);
            transform: scale(1.5);
  }
  100% {
    opacity: 0;
    -webkit-transform: scale(1.5);
            transform: scale(1.5);
  }
}

.shake {
  animation: shake 3s infinite cubic-bezier(.36,.07,.19,.97) both;
}

@keyframes shake {
  2%, 22% {
      transform: translate3d(-1px, 0, 0);
  }

  4%, 20% {
      transform: translate3d(2px, 0, 0);
  }

  7%, 13%, 17% {
      transform: translate3d(-4px, 0, 0);
  }

  10%, 15% {
      transform: translate3d(4px, 0, 0);
  }
}

